BEGIN
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SUSER_BROLE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SUSER_BROLE_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SUSER_SUPERVISOR_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SUSER_SUPERVISOR_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SUSER_BROLE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SUSER_BROLE_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SUSER_SUPERVISOR_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SUSER_SUPERVISOR_V';
                END LOOP;
END;
/

CREATE VIEW suser_brole_v AS
 SELECT suser.id,
    suser.deleted,
    suser.department,
    suser.display_description,
    suser.display_name,
    suser.dn,
    suser.effective,
    suser.employee_status,
    suser.employee_type,
    suser.first_name,
    suser.full_name,
    suser.guid,
    suser.home_phone,
    suser.idm_dn,
    suser.idm_tree_name,
    suser.is_curated,
    suser.job_code,
    suser.job_title,
    suser.last_name,
    suser.location,
    suser.merged,
    suser.middle_name,
    suser.office_phone,
    suser.other_phone,
    suser.preferred_locale,
    suser.provisioning_id,
    suser.secondary_supervisor_id,
    suser.supervisor_attr_key,
    suser.supervisor_id,
    suser.supervisor_unique_id,
    suser.unique_user_id,
    suser.user_id,
    suser.business_unit,
    suser.collected_entity,
    suser.effective_entity,
    suser.identity_source,
    suser.sversion,
    suser.workforce_id,
    suser_email.email,
    suser.risk,
    brole.name business_role,
    brole.description brole_description,
    brole.risk brole_risk,
    brole.update_time brole_update_time
   FROM suser
     LEFT JOIN suser_email ON suser.id = suser_email.suser
     LEFT JOIN business_role_incl_memb br_memb ON suser.unique_user_id = br_memb.unique_member_id AND br_memb.is_user = 1
     LEFT JOIN business_role brole ON br_memb.business_role_id = brole.id
  WHERE suser.deleted = 0 AND suser.effective = 1;

CREATE VIEW suser_supervisor_v AS 
SELECT currentuser.id,
    currentuser.id AS effective_user,
    supervisor.id AS supervisor,
    supervisor.unique_user_id AS supervisor_unique_id,
    supervisor.display_name AS supervisor_name
   FROM suser currentuser
     LEFT JOIN suser supervisor ON currentuser.supervisor_unique_id = supervisor.unique_user_id
  WHERE currentuser.deleted = 0 AND currentuser.effective = 1 AND supervisor.deleted = 0 AND supervisor.effective = 1;

GRANT SELECT ON igops.suser_brole_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM suser_brole_v for igops.suser_brole_v;

GRANT SELECT ON igops.suser_supervisor_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM suser_supervisor_v for igops.suser_supervisor_v;