DROP VIEW IF EXISTS suser_brole_v;
DROP VIEW IF EXISTS suser_supervisor_v;

CREATE VIEW suser_brole_v AS 
SELECT suser.id,
    suser.deleted,
    suser.department,
    suser.display_description,
    suser.display_name,
    suser.dn,
    suser.effective,
    suser.employee_status,
    suser.employee_type,
    suser.first_name,
    suser.full_name,
    suser.guid,
    suser.home_phone,
    suser.idm_dn,
    suser.idm_tree_name,
    suser.is_curated,
    suser.job_code,
    suser.job_title,
    suser.last_name,
    suser.location,
    suser.merged,
    suser.middle_name,
    suser.office_phone,
    suser.other_phone,
    suser.preferred_locale,
    suser.provisioning_id,
    suser.secondary_supervisor_id,
    suser.supervisor_attr_key,
    suser.supervisor_id,
    suser.supervisor_unique_id,
    suser.unique_user_id,
    suser.user_id,
    suser.business_unit,
    suser.collected_entity,
    suser.effective_entity,
    suser.identity_source,
    suser.sversion,
    suser.workforce_id,
    suser_email.email,
    suser.risk,
    brole.name AS business_role,
    brole.description AS brole_description,
    brole.risk AS brole_risk,
    brole.update_time AS brole_update_time
   FROM suser
     LEFT JOIN suser_email ON suser.id = suser_email.suser
     LEFT JOIN business_role_incl_memb br_memb ON suser.unique_user_id::text = br_memb.unique_member_id::text AND br_memb.is_user = true
     LEFT JOIN business_role brole ON br_memb.business_role_id = brole.id
  WHERE suser.deleted = false AND suser.effective = true;

  CREATE VIEW suser_supervisor_v AS 
 SELECT currentuser.id,
    currentuser.id AS effective_user,
    supervisor.id AS supervisor,
    supervisor.unique_user_id AS supervisor_unique_id,
    supervisor.display_name AS supervisor_name
   FROM suser currentuser
     LEFT JOIN suser supervisor ON currentuser.supervisor_unique_id::text = supervisor.unique_user_id::text
  WHERE currentuser.deleted = false AND currentuser.effective = true AND supervisor.deleted = false AND supervisor.effective = true;

ALTER TABLE suser_brole_v
  OWNER TO igops;
GRANT ALL ON TABLE suser_brole_v TO igops;
GRANT SELECT ON TABLE suser_brole_v TO ig_report_role;

ALTER TABLE suser_supervisor_v
  OWNER TO igops;
GRANT ALL ON TABLE suser_supervisor_v TO igops;
GRANT SELECT ON TABLE suser_supervisor_v TO ig_report_role;